/*
 * postal_add_header.c
 * Add a specified header to a header block
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_add_header.c,v 1.5 2003/05/26 06:23:47 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>


int
postal_add_header(POSTAL_MSG *msg, const char *toadd)
{
	char *toret;
	size_t len;

	if(!toadd || !msg || !msg->header)
		return(-1);

	/* Alloc our space.  header+toadd+\n+\0  */
	len = strlen(msg->header) + strlen(toadd) + 1;
	toret = malloc(len+1);
	sprintf(toret, "%s%s\n", msg->header, toadd);

	free(msg->header);
	msg->header=toret;
	msg->hdrlen=len;

	return(0);
}
