/*
 * postal_flush_line.c
 * Flush to EOL
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_flush_line.c,v 1.4 2003/05/26 09:03:30 fullermd Exp $
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>

int
postal_flush_line(int sock)
{
	size_t peek_len, toread=1024;
	char *ptr, *tmpbuf;

	/* XXX  This can be a tight loop eating CPU with a slow server */
	while( (!ptr) )
	{
		/* PEEK as much as we can out of the socket queue */
		peek_len = recv(sock, tmpbuf, toread, MSG_PEEK);
		if( peek_len < 0 )
			return -1;

		/* Look for EOL */
		ptr = memchr( tmpbuf, '\n', peek_len );
		if( ptr != NULL )
		{
			/* XXX This pointer arithmetic might not be portable */
			peek_len = ptr - tmpbuf + 1;
		}
		else
		{
			if(peek_len == toread)
			{
				/* Read more!  God, what a hack */
				toread += 1024;
			}
		}
	}

	/* God, I love dummy buffers :) */
	tmpbuf=malloc(peek_len);
	read(sock, tmpbuf, peek_len);
	free(tmpbuf);

	/* If we got here, things worked */
	return 0;
}
