/*
 * postal_free_msg.c
 * Free a POSTAL_MSG struct
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_free_msg.c,v 1.7 2003/05/26 06:23:47 fullermd Exp $
 */

#include <stdlib.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>


void
postal_free_msg(POSTAL_MSG *tofree)
{
	if(!tofree)
		return;
	if(tofree->header)
		free(tofree->header);
	if(tofree->body)
		free(tofree->body);
	
	/* Check our type */
	switch(tofree->src_type)
	{
		case SRC_MDIR:
			/* Free like we're a Maildir/ */
			free(tofree->loc.file->info);
			free(tofree->loc.file->unique);
			free(tofree->loc.file->filename);
			free(tofree->loc.file);
			break;
		/* SRC_POP and SRC_MBOX don't need anything right now */
	}

	free(tofree);
}
