/*
 * postal_set_header.c
 * Set a header to a specific value
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_set_header.c,v 1.4 2003/05/26 06:23:47 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_extra_p.h>


int
postal_set_header(POSTAL_MSG *msg, const char *hdr, const char *content)
{
	char *head;
	char *tmpbuf;

	if(!hdr || !content || !msg || !msg->header)
		return(-1);

	head = postal_get_header(msg->header, hdr);
	if(head)
	{
		/* Already exists, change it */
		postal_change_header(msg, hdr, content);
		free(head);
	}
	else
	{
		tmpbuf=malloc(strlen(hdr)+strlen(content)+1+1);
		sprintf(tmpbuf, "%s %s", hdr, content);
		postal_add_header(msg, tmpbuf);
		free(tmpbuf);
	}
	
	return(0);
}
