/*
 * mbox_get_message_next.c
 * Get the 'next' message from a mbox
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_get_message_next.c,v 1.14 2003/05/16 14:51:51 fullermd Exp $
 */

#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>
#include <post_raw_extra_p.h>


POSTAL_MSG *
mbox_get_message_next(POSTAL_CONN *p_conn, int get_type)
{
	POSTAL_MSG *toret;

	toret = postal_alloc_msg();

	/*
	 * First record where we're "starting".
	 * We're going to assume that we're at the beginning of
	 * a message within the mbox.
	 * May need to revisit this later and do more error-checking.
	 */
	toret->loc.offset = lseek(p_conn->spec.mbox->desc, 0, SEEK_CUR);
	toret->src_type = SRC_MBOX;

	/* Grab it.  Use mbox_get_message() for simplicity */
	if( (mbox_get_message(p_conn, toret, get_type) < 0) )
	{
		/* Some kinda error */
		free(toret);
		return(NULL);
	}

	return(toret);
}
