/*
 * mbox_write_msg.c
 * Write a message into a mbox
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_write_msg.c,v 1.14 2003/05/16 15:43:29 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>
#include <post_raw_extra_p.h>


void
mbox_write_msg(POSTAL_CONN *p_conn, POSTAL_MSG *msg, int addwhere)
{
	POSTAL_MSG *temp;
	/* XXX - Use a pointer to more easily tell if we've re-seek'd */
	fpos_t *savedpos;

	/* We need to cure \r\n's if we have them... */
	/*
	 * XXX This is a target for optimization.
	 * Waste some memory to save some CPU.  Not worrying right now.
	 */
	temp = postal_alloc_msg();

	temp->body = postal_whack_cr(msg->body);
	temp->bodylen = strlen(temp->body);

	temp->header = postal_whack_cr(msg->header);
	mbox_derive_from(&temp->header);
	mbox_set_conlen(temp);
	mbox_set_status(temp);
	temp->hdrlen = strlen(temp->header);

	/* Get to the right position */
	if(addwhere==POS_END)
	{
		savedpos = malloc(sizeof(fpos_t));
		fgetpos(p_conn->spec.mbox->file, savedpos);
		fseek(p_conn->spec.mbox->file, 0, SEEK_END);
	}
	/* No other cases require moving */

	/* Spew it out */
	fprintf(p_conn->spec.mbox->file,
			"%s\n%s", temp->header, temp->body);

	/* Cleanup */
	postal_free_msg(temp);

	/* *flush*  */
	fflush(p_conn->spec.mbox->file);

	/* If we moved our position manually, return */
	if(savedpos)
	{
		fsetpos(p_conn->spec.mbox->file, savedpos);
		free(savedpos);
	}
}
