/*
 * pop_close.c
 * Close down a POP connection
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_close.c,v 1.5 2003/05/26 09:03:31 fullermd Exp $
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <stdio.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>
#include <post_raw_extra_p.h>


int
pop_close(POSTAL_CONN *to_close)
{
	char buf[BUFFER_SIZE];
	int retval=0;

	/* Send the 'quit' command */
	sprintf(buf, "QUIT\r\n");
	POP_CMD_SEND(to_close, buf);
	CLEARSTRING(buf);

	/* Check the response */
	if( pop_answer_check(to_close) > 0 )
		retval=1;	/* Bad close attempt; no known reason */

	/* Call the backend, and free the structure */
	pop_network_close(to_close);

	return(0);
}
