/*
 * pop_login.c
 * POP login procedure
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_login.c,v 1.4 2003/05/26 09:03:31 fullermd Exp $
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>
#include <post_raw_extra_p.h>


int
pop_login(POSTAL_CONN *p_conn, const char *user, const char *pass)
{
	char buf[BUFFER_SIZE];

	/* Verify username... */
	sprintf(buf, "USER %s\r\n", user);
	POP_CMD_SEND(p_conn, buf);
	CLEARSTRING(buf);

	if( pop_answer_check(p_conn) > 0 )
		return(1);

	/* Verify password */
	sprintf(buf, "PASS %s\r\n", pass);
	POP_CMD_SEND(p_conn, buf);
	CLEARSTRING(buf);

	if( pop_answer_check(p_conn) > 0 )
		return(1);

	/* If we got here, it went through clean */
	return(0);
}
