/*
 * pop_retr_all.c
 * Use RETR to get all messages on server
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_retr_all.c,v 1.8 2002/04/02 04:50:37 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>
#include <post_raw_extra_p.h>

#define ALLOC_CHUNK		128

POSTAL_MSG_GROUP *
pop_retr_all(POSTAL_CONN *p_conn, int dele)
{
	int mnum;
	int alloced=0;
	POP_RET_STAT *ret_stat;
	POSTAL_MSG *ret_retr;
	POSTAL_MSG_GROUP *mgroup;

	mgroup = malloc(PMSGGROUP_SIZE);
	mgroup->num_msgs=0;
	mgroup->msgs=NULL;

	/* First, do a STAT to see how many messages we have */
	ret_stat = pop_stat(p_conn);

	/*
	 * Grab the parsed messages in order, and stick them
	 * into the structure.
	 */
	for(mnum=1 ; mnum <= pop_stat_msgs(ret_stat) ; mnum++)
	{
		/* Retrieve the message */
		ret_retr = pop_retr(p_conn, mnum);

		/* Alloc a struct and point it in */
		mgroup->num_msgs++;

		if(alloced < (mgroup->num_msgs))
		{
			/* Alloc more 'slots' */
			mgroup->msgs = realloc( mgroup->msgs,
					(sizeof(POSTAL_MSG *) * (alloced + ALLOC_CHUNK)) );
			alloced += ALLOC_CHUNK;
		}
		
		(mgroup->msgs)[(mgroup->num_msgs-1)] = ret_retr;

		/* Are we DELE'ing too? */
		if(dele)
			pop_dele(p_conn, mnum);
	}

	/* Avoid a memory leak */
	free(ret_stat);

	/* Prune our memory.  Careful, Marge... */
	mgroup->msgs = realloc( mgroup->msgs,
			(sizeof(POSTAL_MSG *) * (mgroup->num_msgs)) );

	/* That done, just return the puppy */
	return(mgroup);
}
